"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RouteHandler = void 0;
var express_1 = __importDefault(require("express"));
var path_1 = __importDefault(require("path"));
var glob_1 = __importDefault(require("glob"));
var RouteHandler = /** @class */ (function () {
    function RouteHandler(folderLocation) {
        this.folder = path_1.default.join(__dirname, folderLocation);
        this.router = express_1.default.Router();
        this.bindRoutes();
    }
    RouteHandler.prototype.createEndpoints = function (routes) {
        var _this = this;
        return routes.map(function (route) {
            return route
                .replace(_this.folder, '')
                .replace('index.ts', '')
                .replace('.ts', '')
                .replace(/\[[\w]+\]/g, function (match) { return ':' + match.replace(/[\[\]]/g, ''); });
        });
    };
    RouteHandler.prototype.bindRoutes = function () {
        var _this = this;
        glob_1.default(this.folder + "/**/[!_]*.ts", function (error, routes) {
            if (error)
                throw error;
            var endpoints = _this.createEndpoints(routes);
            routes.forEach(function (route, index) {
                _this.router.use(endpoints[index], require(route).default);
            });
        });
    };
    /**
     * getRouter
     */
    RouteHandler.prototype.Router = function () {
        return this.router;
    };
    return RouteHandler;
}());
exports.RouteHandler = RouteHandler;
exports.default = RouteHandler;
